Index: /trunk/src/sys/arch/mips/rmi/rmixl_ehci.c
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_ehci.c	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_ehci.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_ehci.c,v 1.1.2.4 2010/03/21 21:24:48 cliff Exp $	*/
+/*	$NetBSD: rmixl_ehci.c,v 1.1.2.5 2011/04/29 08:26:32 matt Exp $	*/
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: rmixl_ehci.c,v 1.1.2.4 2010/03/21 21:24:48 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: rmixl_ehci.c,v 1.1.2.5 2011/04/29 08:26:32 matt Exp $");
 
 #include "locators.h"
@@ -77,6 +77,7 @@
 rmixl_ehci_attach(device_t parent, device_t self, void *aux)
 {
-	ehci_softc_t *sc = device_private(self);
-	struct rmixl_usbi_attach_args *usbi = aux;
+	ehci_softc_t * const sc = device_private(self);
+	rmixl_usbi_softc_t * const psc = device_private(parent);
+	struct rmixl_usbi_attach_args * const usbi = aux;
 	void *ih = NULL;
 	uint32_t r;
@@ -97,4 +98,16 @@
 	sc->sc_bus.dmatag = usbi->usbi_dmat;
 	sc->sc_bus.usbrev = USBREV_1_0;
+
+	/*
+	 * Grab the companion OHCI devices from our parent.
+	 */
+	if (psc->sc_ohci_devs[1] != NULL) {
+		sc->sc_comps[0] = psc->sc_ohci_devs[0];
+		sc->sc_comps[1] = psc->sc_ohci_devs[1];
+		sc->sc_ncomp = 2;
+	} else {
+		sc->sc_comps[0] = psc->sc_ohci_devs[0];
+		sc->sc_ncomp = 1;
+	}
 
 	if (bus_space_map(sc->iot, usbi->usbi_addr, sc->sc_size, 0, &sc->ioh)) {
Index: /trunk/src/sys/arch/mips/rmi/rmixl_fmn.c
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_fmn.c	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_fmn.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_fmn.c,v 1.1.2.4 2010/04/13 18:15:16 cliff Exp $	*/
+/*	$NetBSD: rmixl_fmn.c,v 1.1.2.7 2011/04/29 08:26:32 matt Exp $	*/
 /*-
  * Copyright (c) 2010 The NetBSD Foundation, Inc.
@@ -33,4 +33,5 @@
 #include <sys/cdefs.h>
 #include <sys/param.h>
+#include <sys/systm.h>
 #include <sys/cpu.h>
 #include <mips/cpuregs.h>
@@ -405,6 +406,7 @@
 	static bool once=false;
 
-	KASSERT(cpu_number() == 0);
-	fmnp = fmn_lookup(cpu_number());
+	KASSERTMSG((CPU_IS_PRIMARY(curcpu())), ("ci=%p, index=%d\n",
+		curcpu(), cpu_index(curcpu())));
+	fmnp = fmn_lookup(curcpu()->ci_cpuid);
 
 	if (once == true)
@@ -481,8 +483,8 @@
 	kmutex_t *lk;
 
-	fmnp = fmn_lookup(cpu_number());
+	fmnp = fmn_lookup(curcpu()->ci_cpuid);
 	KASSERT(fmnp != NULL);
-	KASSERT(fmnp->fmn_core == RMIXL_CPU_CORE(cpu_number()));
-	KASSERT(fmnp->fmn_thread == RMIXL_CPU_THREAD(cpu_number()));
+	KASSERT(fmnp->fmn_core == RMIXL_CPU_CORE(curcpu()->ci_cpuid));
+	KASSERT(fmnp->fmn_thread == RMIXL_CPU_THREAD(curcpu()->ci_cpuid));
 
 	lk = mutex_obj_alloc(MUTEX_DEFAULT, RMIXL_FMN_INTR_IPL);
@@ -634,5 +636,5 @@
 	fmn_t *fmnp;
 
-	fmnp = fmn_lookup(cpu_number());
+	fmnp = fmn_lookup(curcpu()->ci_cpuid);
 	mutex_enter(fmnp->fmn_lock);
 
@@ -645,8 +647,13 @@
 	 * establish dispatcher for FMN interrupt
 	 */
-	void *ih = rmixl_vec_establish(RMIXL_INTRVEC_FMN, -1, RMIXL_FMN_INTR_IPL,
+	extern kmutex_t rmixl_intr_lock;
+	void *ih;
+
+	mutex_enter(&rmixl_intr_lock);
+	ih = rmixl_vec_establish(RMIXL_INTRVEC_FMN, -1, RMIXL_FMN_INTR_IPL,
 		rmixl_fmn_intr_dispatch, fmnp, "fmn");
 	if (ih == NULL)
 		panic("%s: rmixl_vec_establish failed", __func__);
+	mutex_exit(&rmixl_intr_lock);
 	fmnp->fmn_ih = ih;
 #endif
@@ -661,5 +668,5 @@
 	fmn_intrhand_t *ih;
 
-	fmnp = fmn_lookup(cpu_number());
+	fmnp = fmn_lookup(curcpu()->ci_cpuid);
 
 	mutex_enter(fmnp->fmn_lock);
@@ -688,5 +695,5 @@
 	fmn_intrhand_t *ih = cookie;
 
-	fmnp = fmn_lookup(cpu_number());
+	fmnp = fmn_lookup(curcpu()->ci_cpuid);
 	mutex_enter(fmnp->fmn_lock);
 
@@ -782,5 +789,5 @@
 	KASSERT(dest_id <= 0xff);
 
-	fmnp = fmn_lookup(cpu_number());
+	fmnp = fmn_lookup(curcpu()->ci_cpuid);
 	mutex_enter(fmnp->fmn_lock);
         cp0_status = rmixl_cp2_enable();
@@ -817,5 +824,5 @@
 		DELAY(10);		/* XXX ??? */
 	}
-	DIAG_PRF(("%s: cpu=%ld, msg %p, dst_id=%d, sts=%#x: can't send\n",
+	DIAG_PRF(("%s: cpu%u, msg %p, dst_id=%d, sts=%#x: can't send\n",
 		__func__, cpu_number(), msg, dest_id, msg_status));
 	rv = -1;
@@ -823,5 +830,5 @@
  send:
 	desc = RMIXL_MSGSND_DESC(size, code, dest_id);
-	DPRINTF(("%s: cpu %ld, desc %#x\n", __func__, cpu_number(), desc));
+	DPRINTF(("%s: cpu%u, desc %#x\n", __func__, cpu_number(), desc));
 	for (int try=16; try--; ) {
 		rmixl_msgsnd(desc);
@@ -849,5 +856,5 @@
 		}
 		DIAG_PRF(("%s: src=%ld, dst=%d, sts=%#x, %#x: send error, try %d\n",
-			__func__, cpu_number(), dest_id, msg_status, msg_status1, try));
+			__func__, curcpu()->ci_cpuid, dest_id, msg_status, msg_status1, try));
 		DELAY(10);
 	}
@@ -872,5 +879,5 @@
 	int rv;
 
-	fmnp = fmn_lookup(cpu_number());
+	fmnp = fmn_lookup(curcpu()->ci_cpuid);
 	mutex_enter(fmnp->fmn_lock);
 	rv = rmixl_fmn_msg_recv_subr(bucket, rxmsg);
@@ -893,5 +900,5 @@
 	int rv;
 
-	fmnp = fmn_lookup(cpu_number());
+	fmnp = fmn_lookup(curcpu()->ci_cpuid);
 	KASSERT(mutex_owned(fmnp->fmn_lock) != 0);
 
@@ -901,5 +908,5 @@
 			goto recv;
 	}
-	DIAG_PRF(("%s: cpu=%ld, bucket=%d, sts=%#x: Load Pending Fail\n",
+	DIAG_PRF(("%s: cpu%u, bucket=%d, sts=%#x: Load Pending Fail\n",
 		__func__, cpu_number(), bucket, msg_status));
 	rv = -1;
@@ -908,5 +915,5 @@
 	rmixl_msgld(bucket);
 	RMIXL_MFC2(RMIXL_COP_2_MSG_STS, 0, msg_status);
-	DPRINTF(("%s: cpu=%ld, bucket=%d, sts=%#x\n",
+	DPRINTF(("%s: cpu%u, bucket=%d, sts=%#x\n",
 		__func__, cpu_number(), bucket, msg_status));
 	rv = msg_status & (RMIXL_MSG_STS0_LEF|RMIXL_MSG_STS0_LPF);
@@ -1142,5 +1149,5 @@
 	FMN_CP2_4SEL_READ(RMIXL_COP_2_CREDITS+3, 4, &cc[3][4]);
 
-	printf("%s: cpu %ld\n", __func__, cpu_number());
+	printf("%s: cpu%u\n", __func__, cpu_number());
 	for (int i=0; i < 4; i++) {
 		for (int j=0; j < 8; j++)
Index: /trunk/src/sys/arch/mips/rmi/rmixl_fmnvar.h
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_fmnvar.h	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_fmnvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$Id: rmixl_fmnvar.h,v 1.1.2.3 2010/04/13 18:15:16 cliff Exp $	*/
+/*	$Id: rmixl_fmnvar.h,v 1.1.2.4 2011/04/29 08:26:32 matt Exp $	*/
 /*-
  * Copyright (c) 2010 The NetBSD Foundation, Inc.
@@ -151,5 +151,5 @@
 		".set push"		"\n\t"
 		".set noreorder"	"\n\t"
-		".set mips64"		"\n\t"
+		".set arch=xlr"		"\n\t"
 		"sync"			"\n\t"
 		"msgsnd %0"		"\n\t"
@@ -164,5 +164,5 @@
 		".set push"		"\n\t"
 		".set noreorder"	"\n\t"
-		".set mips64"		"\n\t"
+		".set arch=xlr"		"\n\t"
 		"msgld %0"		"\n\t"
 		".set pop"		"\n\t"
@@ -180,5 +180,5 @@
 		".set push"		"\n\t"
 		".set noreorder"	"\n\t"
-		".set mips64"		"\n\t"
+		".set arch=xlr"		"\n\t"
 		"addu %0,%0,0"		"\n\t"
 		"msgwait %0"		"\n\t"
